//+------------------------------------------------------------------+
//|                                                      Andy007.mq4 |
//|                                      Copyright 2010, Zsolt Szabo |
//|                                     http://www.fkfl.com/ForSale/ |
//+------------------------------------------------------------------+
/*
 */
 
#property copyright "Copyright 2010, Zsolt Szabo."
#property link      "http://www.fkfl.com/ForSale/"
// Client: Zsolt
// Tags: 
// Revision: 1

/* Change Logs */
/*
*/

//+------------------------------------------------------------------+
//| Universal Constants                                              |
//+------------------------------------------------------------------+
#define TRADEPEND  -1
#define TRADEALL   0
#define TRADETRADE 1
#define TRADEBUY   1
#define TRADESELL  -1

#define PHASE_NONE 0
#define PHASE_BUY 1
#define PHASE_SELL -1

//+------------------------------------------------------------------+
//| User input variables                                             |
//+------------------------------------------------------------------+
extern string     AdvisorName = "Zsolt_C2Ac_EA";          // For Logging
extern string  AdvisorVersion = "1.0.1";            // The version number of this script
extern string     ProjectPage = "http://www.fkfl.com/ForSale/";            // The project landing page
// iMACD
extern string  MACD_M30_iMACD = "";
extern int      MACD_M30_TF = PERIOD_M30;
extern int      MACD_M30_Fast = 24;          // Fast EMA Period
extern int      MACD_M30_Slow = 52;          // Slow EMA Period
extern int    MACD_M30_Signal = 9;           // Signal Line Period
extern int     MACD_M30_Price = 0;           // 0=close, 1=open, 2=high, 3=low, 4=median, 5=typical, 6=weighted
// iMACD
extern string  MACD_M30B_iMACD = "";
extern int      MACD_M30B_TF = PERIOD_M30;
extern int      MACD_M30B_Fast = 9;          // Fast EMA Period
extern int      MACD_M30B_Slow = 55;          // Slow EMA Period
extern int    MACD_M30B_Signal = 9;           // Signal Line Period
extern int     MACD_M30B_Price = 0;           // 0=close, 1=open, 2=high, 3=low, 4=median, 5=typical, 6=weighted
// iMA
extern string       MA_M30_iMA = "";
extern int       MA_M30_TF = PERIOD_M30;
extern int       MA_M30_Period = 55;           // MA Period
extern int        MA_M30_Shift = 0;           // MA Shift
extern int       MA_M30_Method = 1;           // 0=sma, 1=ema, 2=smma, 3=lwma
extern int        MA_M30_Price = 0;           // 0=close, 1=open, 2=high, 3=low, 4=median, 5=typical, 6=weighted
// iATR
extern string ATR_TP_Indicator = "";
extern int       ATR_TP_TF = PERIOD_H4;
extern int       ATR_TP_Period = 500;
// iATR
extern string ATR_SL_Indicator = "";
extern int       ATR_SL_TF = PERIOD_M30;
extern int       ATR_SL_Period = 500;
// Entry & Exit
extern string Entry_Exit = "Entry & Exit Settings";
extern bool TradeAtBarOpen = false; // If true, will check the signal at the close of the bar, for confirming signal
extern bool TradeBuyOn = true;      // Whether open buy trades
extern bool TradeSellOn = true;     // Whether open sell trades
extern bool Exit_MACD = false;       // Whether use the MACD exit logic, signal by MACD_M15B_iMACD
extern bool ExitAtBarOpen = false;  // Only for Exit_MACD, for confirming signal
extern string Display = "Display Settings";
extern bool   DisplayControl = true;
extern int    Display_X_Cord = 20;
extern int    Display_Y_Cord = 20;
extern color  Display_Label_Color = White;
extern color  Display_Value_Color = White;
extern int    DisplayFontSize = 9;
// Trade Time Filter
extern string Trade_Time_Filter = "";
extern bool   TradeTimeFilter = false;          // Whether to use trade time filter
extern string      TradeBegin = "07:00";       // Don't trade before this time
extern string        TradeEnd = "19:00";       // Don't trade after this time
extern bool     EndInTomorrow = false;         // Whether TradeEnd is the next day, like you want to trade the period: 18:00~06:00, the 06:00 is the next am
// Order Operation - Open
extern string Order_Operation_Open = "";
extern bool         ECNBroker = true;         // Whether using ECN broker
extern int              Magic = 433333;        // For identify trades belong to this EA, set to unique on different chart when using at the same time
extern int           Slippage = 3;             // Allow slippage
extern double            Lots = 0.1;           // Fixed trade lots without using MoneyManagement
extern bool   MoneyManagement = false;         // Whether using Money Management
extern double MM_Target_Equity = 0;            // 0 for all the equity. Reference by MM_Risk, be an initial equity for this robot
extern double         MM_Risk = 5;             // Risk as equity (for stoploss), in percent
extern bool       StealthMode = false;         // Whether TakeProfit and StopLoss in Stealth Mode, hiding from the broker
extern double      TakeProfit = 79;             // In Pips. Take Profit, Change to 0 if you don't want to use.
extern double        StopLoss = 48;             // In Pips. Stop Loss, Change to 0 if you don't want to use.
extern bool       ATR_TP = false;               // Whether use ATR for TakeProfit. Will override the fixing settings and can not use in stealth mode
extern double     ATR_TP_Value = 200;          // In percentage.
extern bool       ATR_SL = false;               // Whether use ATR for StopLoss. Will override the fixing settings and can not use in stealth mode
extern double     ATR_SL_Value = 150;          // In percentage.
// Order Operation - Break Even:
extern string Order_Operation_BreakEven = "";
extern bool      UseBreakEven = true;          // Whether using BreakEven
extern bool    BE_StealthMode = false;         // Whether using BreakEven in Stealth Mode
extern double   BreakEvenPips = 26;            // In Pips. BreakEven Pips.
extern bool BreakEvenWithProfit = true;       // Different from normal BreakEven, you can make a little in BreakEven, like 1~2 pips
extern double BreakEvenProfit = 10;             // In Pips. BreakEven Pips take profit.
// Order Operation - Trailing Stop: 
extern string Order_Operation_Trailing_Stop = "";
extern bool      UseTrailStop = false;          // Whether using TrailStop
extern bool    TrailAfterEven = false;          // Whether using TrailStop after the range between current price and the OrderOpenPrice >= TrailStopPips
extern bool    TS_StealthMode = false;         // Whether using TrailStop in Stealth Mode
extern double   TrailStopPips = 20;            // In Pips. TrailStop Pips
extern bool  TS_MovingInChunk = false;         // Whether wait for price move a range to set new SL
extern double        TS_Chunk = 10;            // In Pips. Moving pips as chunk


//+------------------------------------------------------------------+
//| Universal variables                                              |
//+------------------------------------------------------------------+
double macd_m30b_sig[3], macd_m30_sig[3];
double ma_m30[3];
double atr_tp, atr_sl;
int bar=0, bar_exit=0, i=0;
int phase=PHASE_NONE;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   if(TradeAtBarOpen) {
      bar = 1;
   }
   if(ExitAtBarOpen) {
      bar_exit = 1;
   }
   
   if(DisplayControl) {
      displayShow();
   }
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   // Clear the un-used Global Variables
   GlobalVariablesDeleteAll(AdvisorName);
   objClear(AdvisorName);

   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   // BreakEven && TrailStop && StealthMode
   if(scanTrades(TRADETRADE)>0) {
      if(UseBreakEven) breakEven();
      if(UseTrailStop) trailStop();
      if(StealthMode) stealthMode();
   }
   
   for(i=0; i<3; i++) {
      macd_m30b_sig[i] = iMACD(Symbol(), MACD_M30B_TF, MACD_M30B_Fast, MACD_M30B_Slow, MACD_M30B_Signal, MACD_M30B_Price, MODE_SIGNAL, i);
      macd_m30_sig[i] = iMACD(Symbol(), MACD_M30_TF, MACD_M30_Fast, MACD_M30_Slow, MACD_M30_Signal, MACD_M30_Price, MODE_SIGNAL, i);
      ma_m30[i] = iMA(Symbol(), MA_M30_TF, MA_M30_Period, MA_M30_Shift, MA_M30_Method, MA_M30_Price, i);
      
   }
   
   atr_tp = iATR(Symbol(), ATR_TP_TF, ATR_TP_Period, 0);
   atr_sl = iATR(Symbol(), ATR_SL_TF, ATR_SL_Period, 0);
   
   // Trade Time Filter
   if(!TradeTimeFilter || (TradeTimeFilter && tradeTime())) {   
      if(ma_m30[bar+1]>ma_m30[bar+2]
         && macd_m30_sig[bar+1]>macd_m30_sig[bar+2]
         && macd_m30_sig[bar]>macd_m30_sig[bar+1]
         && ma_m30[bar]>ma_m30[bar+1]
         && TradeBuyOn && phase!=PHASE_BUY) {
         phase = PHASE_BUY;
         tradeBuy();
      }
      if(ma_m30[bar+1]<ma_m30[bar+2]
         && macd_m30_sig[bar+1]<macd_m30_sig[bar+2]
         && macd_m30_sig[bar]<macd_m30_sig[bar+1]
         && ma_m30[bar]<ma_m30[bar+1]
         && TradeSellOn && phase!=PHASE_SELL) {
         phase = PHASE_SELL;
         tradeSell();
      }
   }
   
   if(Exit_MACD && scanTrades(TRADETRADE)>0) {
      if(scanTrades(TRADETRADE,TRADEBUY)>0 && macd_m30_sig[bar_exit]<macd_m30_sig[bar_exit+1]) {
         closeTradesBuy();
      }
      if(scanTrades(TRADETRADE,TRADESELL)>0 && macd_m30_sig[bar_exit]>macd_m30_sig[bar_exit+1]) {
         closeTradesSell();
      }
   }
   
   if(DisplayControl) {
      displayShow();
   }
   
   return(0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void displayShow()
  {
   int x, y;
   x = Display_X_Cord;
   y = Display_Y_Cord;
   
   objLabel(AdvisorName+"_StopLoss", "Stop Loss", 0, x, y, 0, Display_Label_Color, "Arial", DisplayFontSize);
   
   double stop_loss;
   if(ATR_SL) {
      stop_loss = atr_sl * ATR_SL_Value/100;
      stop_loss = points2Pips((MathPow(10,Digits) * stop_loss));
   }
   else {
      stop_loss = StopLoss;
   }
   objLabel(AdvisorName+"_StopLoss_Value", DoubleToStr(stop_loss,1), 0, x, y+fontVal(2), 0, Display_Label_Color, "Arial", DisplayFontSize);
   
   double balance;
   if(MoneyManagement && MM_Target_Equity>0) {
      balance = MM_Target_Equity;
   }
   else {
      balance = AccountEquity();
   }
   objLabel(AdvisorName+"_AccountBalance", "Account Balance", 0, x+fontVal(9), y, 0, Display_Label_Color, "Arial", DisplayFontSize);
   objLabel(AdvisorName+"_AccountBalance_Value", "$ "+DoubleToStr(balance,2), 0, x+fontVal(9), y+fontVal(2), 0, Display_Label_Color, "Arial", DisplayFontSize);
   
   
   objLabel(AdvisorName+"_Risk", "Risk", 0, x+fontVal(24), y-fontVal(1), 0, Display_Label_Color, "Arial", DisplayFontSize);   
   objLabel(AdvisorName+"_Risk_%", "%", 0, x+fontVal(22), y, 0, Display_Label_Color, "Arial", DisplayFontSize);
   objLabel(AdvisorName+"_Risk_Value1", DoubleToStr(MM_Risk,1)+" %", 0, x+fontVal(22), y+fontVal(2), 0, Display_Label_Color, "Arial", DisplayFontSize);
   objLabel(AdvisorName+"_Risk_$", "$", 0, x+fontVal(28), y, 0, Display_Label_Color, "Arial", DisplayFontSize);
   double balance_risk = balance*MM_Risk/100;
   objLabel(AdvisorName+"_Risk_Value2", "$ "+DoubleToStr(balance_risk,2), 0, x+fontVal(28), y+fontVal(2), 0, Display_Label_Color, "Arial", DisplayFontSize);

   double take_profit, target_amount, tick_value;
   tick_value = MarketInfo(Symbol(), MODE_TICKVALUE);
   if(ATR_TP) {
      take_profit = atr_tp * ATR_TP_Value/100;
      target_amount = MathPow(10,Digits) * take_profit * tick_value;
      take_profit = points2Pips(MathPow(10,Digits) * take_profit);
   }
   else {
      take_profit = TakeProfit;
      target_amount = pips2Points(TakeProfit) * tick_value;
   }
   objLabel(AdvisorName+"_Target", "Target", 0, x, y+fontVal(4), 0, Display_Label_Color, "Arial", DisplayFontSize);
   objLabel(AdvisorName+"_TargetValue", DoubleToStr(take_profit,1), 0, x, y+fontVal(6), 0, Display_Label_Color, "Arial", DisplayFontSize);
   
   objLabel(AdvisorName+"_InvestedAmount", "Invested Amount", 0, x+fontVal(7), y+fontVal(4), 0, Display_Label_Color, "Arial", DisplayFontSize);
   objLabel(AdvisorName+"_InvestedAmountValue", DoubleToStr(AccountMargin(),2), 0, x+fontVal(7), y+fontVal(6), 0, Display_Label_Color, "Arial", DisplayFontSize);
  
   objLabel(AdvisorName+"_TargetAmount", "Target Amount", 0, x+fontVal(22), y+fontVal(4), 0, Display_Label_Color, "Arial", DisplayFontSize);
   objLabel(AdvisorName+"_TargetAmount_Value", DoubleToStr(target_amount,2), 0, x+fontVal(22), y+fontVal(6), 0, Display_Label_Color, "Arial", DisplayFontSize);

  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double fontVal(int mul)
  {
   return(mul*DisplayFontSize);
  }
  


//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
bool tradeTime()
  {
   if(TradeTimeFilter) {
      datetime time_now, time_begin, time_end, time_end_today;
      time_now = TimeCurrent();
      time_begin = StrToTime(TradeBegin);
      if(!EndInTomorrow) {
         time_end = StrToTime(TradeEnd);
      }
      else if(EndInTomorrow) {
         time_end = StrToTime(TradeEnd) + 86400;
         time_end_today = StrToTime(TradeEnd);
      }
      if(!EndInTomorrow && (time_now<time_begin || time_now>time_end)) {
         return(false);
      }
      else if(EndInTomorrow && time_now>time_end_today && time_now<time_begin) {
         return(false);
      }
   }
   return(true);  
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
void tradeBuy()
  {
   double price_now, price_profit, price_stop, lots;
   double take_profit = pips2Points(TakeProfit)*Point;
   double stop_loss = pips2Points(StopLoss)*Point;
   int ticket;
   
   if(ATR_TP) {
      take_profit = atr_tp * ATR_TP_Value/100;
   }
   if(ATR_SL) {
      stop_loss = atr_sl * ATR_SL_Value/100;
   }
   
   price_now = Ask;
   if(TakeProfit > 0) {
      price_profit = price_now + take_profit;
   }
   else {
      price_profit = 0;
   }
   if(StopLoss > 0) {
      price_stop = price_now - stop_loss;
   }
   else {
      price_stop = 0;
   }

   if(MoneyManagement) {
      lots = mmLots(stop_loss);
   }
   else {
      lots = Lots;
   }
   
   if(!ECNBroker && !StealthMode) {
      ticket = OrderSend(Symbol(), OP_BUY, lots, price_now, Slippage, price_stop, price_profit, NULL, Magic, 0, Lime);
   }
   else {
      ticket = OrderSend(Symbol(), OP_BUY, lots, price_now, Slippage, 0, 0, NULL, Magic, 0, Lime);
   }
   
   if(ticket < 0) {
      //tradeBuy();
      Print(AdvisorName, "- tradeBuy() error #", GetLastError());
      Print("Price Buy: ", price_now, " TP: ", price_profit, " SL: ", price_stop, " Lots: ", lots);
   }
   else {
      if(ECNBroker) {  
         OrderSelect(ticket, SELECT_BY_TICKET);
         OrderModify(OrderTicket(), OrderOpenPrice(), price_stop, price_profit, 0, CLR_NONE);
      }
   }
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
void tradeSell()
  {
   double price_now, price_profit, price_stop, lots;
   double take_profit = pips2Points(TakeProfit)*Point;
   double stop_loss = pips2Points(StopLoss)*Point;
   int ticket;
   
   if(ATR_TP) {
      take_profit = atr_tp * ATR_TP_Value/100;
   }
   if(ATR_SL) {
      stop_loss = atr_sl * ATR_SL_Value/100;
   }
   
   price_now = Bid;
   if(TakeProfit > 0) {
      price_profit = price_now - take_profit;
   }
   else {
      price_profit = 0;
   }
   if(StopLoss > 0) {
      price_stop = price_now + stop_loss;
   }
   else {
      price_stop = 0;
   }

   if(MoneyManagement) {
      lots = mmLots(stop_loss);
   }
   else {
      lots = Lots;
   }

   if(!ECNBroker && !StealthMode) {
      ticket = OrderSend(Symbol(), OP_SELL, lots, price_now, Slippage, price_stop, price_profit, NULL, Magic, 0, Red);
   }
   else {
      ticket = OrderSend(Symbol(), OP_SELL, lots, price_now, Slippage, 0, 0, NULL, Magic, 0, Red);
   }
   
   if(ticket < 0) {
      //tradeBuy();
      Print(AdvisorName, "- tradeSell() error #", GetLastError());
      Print("Price Sell: ", price_now, " TP: ", price_profit, " SL: ", price_stop, " Lots: ", lots);
   }
   else {
      if(ECNBroker) {
         OrderSelect(ticket, SELECT_BY_TICKET);
         OrderModify(OrderTicket(), OrderOpenPrice(), price_stop, price_profit, 0, CLR_NONE);
      }
   }
  }
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void closeTradesBuy()
  {
   int trades_total = OrdersTotal();
   for(int i=0; i<trades_total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==Magic) {
         OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_BID), Slippage, White);
      }
   }
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void closeTradesSell()
  {
   int trades_total = OrdersTotal();
   for(int i=0; i<trades_total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==Magic) {
         OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_ASK), Slippage, White);
      }
   }
  }
    
//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
void stealthMode()
  {
   double takeprofit_stealth = pips2Points(TakeProfit)*Point;
   double stoploss_stealth = pips2Points(StopLoss)*Point;
      
   for(int i=0; i<OrdersTotal(); i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
         if(OrderType()==OP_BUY && takeprofit_stealth>0
            && (MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice()>=takeprofit_stealth
               || OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_BID)>=stoploss_stealth)) {
            OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, White);
         }
         else if(OrderType()==OP_SELL && stoploss_stealth>0
            && (OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK)>=takeprofit_stealth
               || MarketInfo(OrderSymbol(),MODE_ASK)-OrderOpenPrice()>=stoploss_stealth)) {
            OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, White);
         }
      }
   }
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double pips2Points(double pips)
  {
   double points;
   if(Close[0]<10) {
      points = pips*MathPow(10,Digits-4);
   }
   else if(Close[0]>10) {
      points = pips*MathPow(10,Digits-2);  
   }
   
   return(points);
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double points2Pips(double points)
  {
   double pips;
   if(Close[0]<10) {
      pips = points/MathPow(10,Digits-4);
   }
   else if(Close[0]>10) {
      pips = points/MathPow(10,Digits-2);
   }
   
   return(pips);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
int scanTrades(int order_type=TRADEALL, int order_dir=TRADEALL)
  {
   int orders_total = OrdersTotal();
   int orders_number = 0;
   for(int i=0; i<orders_total; i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) {
         switch(order_type) {
            case TRADEALL:
               orders_number++;
               break;
            case TRADETRADE:
               if(OrderType()<=OP_SELL) {
                  orders_number = _scanTradesDir(order_dir, orders_number);
               }
               break;
            case TRADEPEND:
               if(OrderType()>OP_SELL) {
                  orders_number = _scanTradesDir(order_dir, orders_number);
               }
               break;
         }// switch
      }
   }
   return(orders_number);   
  }
  
int _scanTradesDir(int order_dir, int orders_number)
  {
      switch(order_dir) {
         case TRADEALL:
            orders_number++;
            break;
         case TRADEBUY:
            if(OrderType()==OP_BUY || OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) {
               orders_number++;
            }
            break;
         case TRADESELL:
            if(OrderType()==OP_SELL || OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP) {
               orders_number++;
            }
            break;
      }// switch
      return(orders_number);
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void breakEven()
  {
   int orders_total = OrdersTotal();
   int i, ticket;
   double break_even_points = pips2Points(BreakEvenPips);
   double break_even_with_profit = pips2Points(BreakEvenWithProfit);
   double stoploss_buy, stoploss_sell;
   string gv_name;
   double break_even_able;
   
   for(i=0; i<orders_total; i++) {
      break_even_able = -1;
      if(!BreakEvenWithProfit) {
         stoploss_buy = OrderOpenPrice();
         stoploss_sell = OrderOpenPrice();
      }
      else {
         stoploss_buy = OrderOpenPrice() + break_even_with_profit*Point;
         stoploss_sell = OrderOpenPrice() - break_even_with_profit*Point;
      }
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderProfit()>0) {
         if(BE_StealthMode) {
            break_even_able = GlobalVariableGet(AdvisorName+"_be_able_"+OrderTicket());
            if(OrderType()==OP_BUY && break_even_able>0 && Bid<=stoploss_buy) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, White);
            }
            else if(OrderType()==OP_SELL && break_even_able>0 && Ask>=stoploss_sell) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, White);
            }
         }
      
         if(OrderType()==OP_BUY && (OrderStopLoss()<stoploss_buy || OrderStopLoss()==0)
            && Bid-OrderOpenPrice()>=break_even_points*Point) {
            if(!BE_StealthMode) {
               OrderModify(OrderTicket(), OrderOpenPrice(), stoploss_buy, OrderTakeProfit(), 0, Green);
            }
            else {
               GlobalVariableSet(AdvisorName+"_be_able_"+OrderTicket(), 1);
            }
         }
         else if(OrderType()==OP_SELL && (OrderStopLoss()>stoploss_sell || OrderStopLoss()==0)
            && OrderOpenPrice()-Ask>=break_even_points*Point) {
            if(!BE_StealthMode) {
               OrderModify(OrderTicket(), OrderOpenPrice(), stoploss_sell, OrderTakeProfit(), 0, Magenta);
            }
            else {
               GlobalVariableSet(AdvisorName+"_be_able_"+OrderTicket(), 1);
            }
         }
      }
   }
   
   // Clear the un-used Global Variables
   for(i=0; i<GlobalVariablesTotal(); i++) {
      gv_name = GlobalVariableName(i);
      if(StringSubstr(gv_name, 0, 8+StringLen(AdvisorName))==AdvisorName+"_be_able") {
         ticket = StrToInteger(StringSubstr(gv_name, 8+StringLen(AdvisorName)));
         OrderSelect(ticket, SELECT_BY_TICKET);
         if(OrderCloseTime()>0) {
            GlobalVariableDel(gv_name);
         }
      }
   }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void trailStop()
  {
   int ticket;
   string gv_name;
   double trail_stop_points = pips2Points(TrailStopPips)*Point;
   double ts_chunk = pips2Points(TS_Chunk)*Point;
   double stoploss_order;
   
   for(int i=0; i<OrdersTotal(); i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
         if(!TS_StealthMode) {
            stoploss_order = OrderStopLoss();
         }
         else {
            stoploss_order = GlobalVariableGet("ts_stoploss_"+OrderTicket());
            
            if(stoploss_order>0) {
               if(OrderType()==OP_BUY && Bid<=stoploss_order) {
                  OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, White);
                  GlobalVariableDel(AdvisorName+"_ts_stoploss_"+OrderTicket());
                  continue;
               }
               else if(OrderType()==OP_SELL && Ask>=stoploss_order) {
                  OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, White);
                  GlobalVariableDel(AdvisorName+"_ts_stoploss_"+OrderTicket());
                  continue;
               }
            }
         }

         if(OrderType()==OP_BUY
            && ((Bid-trail_stop_points>stoploss_order && stoploss_order>0) || stoploss_order==0)
            && (!TrailAfterEven || (TrailAfterEven && Bid-trail_stop_points>=OrderOpenPrice()))
            && (!TS_MovingInChunk || (TS_MovingInChunk && ((Bid-stoploss_order>trail_stop_points+ts_chunk && stoploss_order>0) || stoploss_order==0)))) {
            if(!TS_StealthMode) {
               OrderModify(OrderTicket(), OrderOpenPrice(), Bid-trail_stop_points, OrderTakeProfit(), 0, Blue);
            }
            else {
               GlobalVariableSet(AdvisorName+"_ts_stoploss_"+OrderTicket(), Bid-trail_stop_points);
            }
         }
         else if(OrderType()==OP_SELL
            && ((Ask+trail_stop_points<stoploss_order && stoploss_order>0) || stoploss_order==0)
            && (!TrailAfterEven || (TrailAfterEven && Ask+trail_stop_points<=OrderOpenPrice()))
            && (!TS_MovingInChunk || (TS_MovingInChunk && ((stoploss_order-Ask>trail_stop_points+ts_chunk && stoploss_order>0) || stoploss_order==0)))) {
            if(!TS_StealthMode) {
               OrderModify(OrderTicket(), OrderOpenPrice(), Ask+trail_stop_points, OrderTakeProfit(), 0, Orange);
            }
            else {
               GlobalVariableSet(AdvisorName+"_ts_stoploss_"+OrderTicket(), Ask+trail_stop_points);
            }
         }
      }
   }
   
   // Clear the un-used Global Variables
   for(i=0; i<GlobalVariablesTotal(); i++) {
      gv_name = GlobalVariableName(i);
      if(StringSubstr(gv_name, 0, 12+StringLen(AdvisorName))==AdvisorName+"_ts_stoploss") {
         ticket = StrToInteger(StringSubstr(gv_name, 12+StringLen(AdvisorName)));
         OrderSelect(ticket, SELECT_BY_TICKET);
         if(OrderCloseTime()>0) {
            GlobalVariableDel(gv_name);
         }
      }
   }
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+  
double mmLots(double tick_stoploss)
  {
   // Use the fixed Lots
   if(tick_stoploss==0) {
      return(Lots);
   }
   
   double equity = AccountEquity();
   if(MM_Target_Equity>0) {
      equity = MM_Target_Equity;
   }
   
   double tick_value = MarketInfo(Symbol(), MODE_TICKVALUE);
   double lots_equity = equity * MM_Risk/100;
   double lots = NormalizeDouble(lots_equity/(MathPow(10,Digits)*tick_stoploss*tick_value), 1);
   
   return(lots);
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void objClear(string prefix) 
  {
   string name;
   int obj_total = ObjectsTotal();
   for (int i=obj_total-1; i>=0; i--) {
      name = ObjectName(i);
      if (StringFind(name, prefix) == 0) ObjectDelete(name);
   }
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void objLabel(string name, string tex, int corner, int position_x, int position_y, int window=0, color tex_color=White, string tex_font="Arial", int tex_size=12)
  {
   if(ObjectFind(name)==-1) {
      ObjectCreate(name, OBJ_LABEL, window, 0, 0);
   }
   ObjectSet(name, OBJPROP_CORNER, corner);
   ObjectSet(name, OBJPROP_XDISTANCE, position_x);
   ObjectSet(name, OBJPROP_YDISTANCE, position_y);
   ObjectSetText(name, tex, tex_size, tex_font, tex_color);
  }